namespace CMSMicroservice.Application.ProductTagCQ.Commands.CreateNewProductTag;
public class CreateNewProductTagCommandValidator : AbstractValidator<CreateNewProductTagCommand>
{
    public CreateNewProductTagCommandValidator()
    {
        RuleFor(model => model.ProductId)
            .NotNull();
        RuleFor(model => model.TagId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewProductTagCommand>.CreateWithOptions((CreateNewProductTagCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
